﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Boat : MonoBehaviour
{
	public  float rotateSpeed = -90f;
	public  float horizontalSpeed = 2f;   	

    private Rigidbody2D rb;
	private float xPosition;
	private bool ifFreeze = true;

	// Use this for initialization
	void Start ()
    {
        rb = this.GetComponent<Rigidbody2D>();
		xPosition = transform.position.x;
	}
	
	// Update is called once per frame
	void Update ()
    {
		if (GlobalVariables.gameBegan)
		{
			Vector2 vel = rb.velocity;
			vel.x = horizontalSpeed;
			rb.velocity = vel;

			if (Input.GetAxis ("Horizontal") != 0f)
			{
				rb.angularVelocity = 0f;
				rb.AddTorque (Input.GetAxis ("Horizontal") * rotateSpeed);
			}
		}
			
        GlobalVariables.levelProgress = this.transform.position.x + GlobalVariables.waterLeft;
		if (ifFreeze)
		{
			transform.position = new Vector3 (xPosition, transform.position.y, transform.position.z);
		}
    }

    void OnTriggerEnter2D(Collider2D collision)
    {
        if(collision.GetComponent<Collider2D>().tag.Equals("LevelEnd"))
        {
            GlobalVariables.currentLevelState = 2;
        }
    }

	public void FreezeX ()
	{
		xPosition = transform.position.x;
		ifFreeze = true;
	}

	public void UnFreezeX ()
	{
		ifFreeze = false;
	}
}
