﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Cam : MonoBehaviour
{
    public Transform boat;
    public bool drunk = false;
	public float height;
	public float followSpeed;
	/*public float a;//testing variable
	public float b;
	public float c;*/
	private Transform goalPosition;
    private bool isFollowing = true;
	public Transform goal;

	void Start ()
	{
		transform.position = new Vector3 (boat.position.x, this.transform.position.y, -10f);
		if (GlobalVariables.lastCameraPosition != Vector3.zero)
		{
			transform.position = GlobalVariables.lastCameraPosition;
		}
	}

    public void SetFollowing (bool shouldFollow)
    {
        isFollowing = shouldFollow;
    }

    public void SetBoat(Transform newBoat)
    {
        boat = newBoat;
    }

    void Update()
    {
		if (!GlobalVariables.win)
		{
			if (GlobalVariables.gameBegan)
			{
				if (isFollowing && GlobalVariables.level != 2)
					transform.position = Vector3.Lerp (transform.position, new Vector3 (boat.position.x, boat.position.y + height, -10f), Time.deltaTime * followSpeed);
				if (isFollowing)
					transform.position = Vector3.Lerp (transform.position, new Vector3 (boat.position.x, boat.position.y, -10f), Time.deltaTime * followSpeed);

				/*if (drunk)
			{
				transform.rotation = boat.rotation;
			} else
			{
				transform.rotation = Quaternion.identity;
			}*/

				/*if (Input.GetKeyDown (KeyCode.T))//test Shake
		{
			ShakeCam (a, b, c);
		}*/
			} else
			{
				transform.position = Vector3.Lerp (transform.position, new Vector3 (boat.position.x, transform.position.y, -10f), Time.deltaTime * followSpeed);
			}
		} else
		{
			transform.position = Vector3.Lerp (transform.position, new Vector3 (goal.position.x, transform.position.y, -10f), Time.deltaTime);
		}
    }

    public void SetTargetPosition (Vector3 position)
    {
        if(isFollowing)
        {
            int dir = 0;

            if (position.x > this.transform.position.x)
            {
                dir = 10;
            }
            else
            {
                dir = -10;
            }

            StartCoroutine(MoveToPosition(position, dir));
        }        
    }

    IEnumerator MoveToPosition (Vector3 position, int direction)
    {
        isFollowing = false;
        while ((direction < 0 && this.transform.position.x > position.x) ||
                (direction > 0 && this.transform.position.x < position.x))
        {
            //this.transform.position += new Vector3(direction, 0f, 0f) * Time.deltaTime;
			this.transform.position = Vector3.Lerp(transform.position, new Vector3(position.x, this.transform.position.y,this.transform.position.z), Time.deltaTime);
            yield return new WaitForSeconds(Time.deltaTime);
        }

        isFollowing = true;
		Debug.Log("ienum cam" + position + "   "+ transform.position);
        GlobalVariables.startNewLevel2 = true;
    }

	public void ShakeCam (float time, float frequence, float distance)//0.1 100 0.5 are some good argument
	{
		StartCoroutine (ShakeCamCoroutine (time, frequence, distance));
	}

	IEnumerator ShakeCamCoroutine (float time, float frequence, float distance)
	{
        isFollowing = false;
		Vector3 camPos = Camera.main.transform.position;
		float timer = 0;
		while (time > timer)
		{
			Vector3 newCamPos = new Vector3 (Random.value * distance * 2 - distance, 
				Random.value * distance * 2 - distance, camPos.z) + camPos;
			
			Camera.main.transform.position = newCamPos;
			timer += 1f / frequence;
			yield return new WaitForSeconds (1f / frequence);
		}
		Camera.main.transform.position = camPos;
        isFollowing = true;
	}
}
