﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour
{
	public Boat[] boats;
    public Water[] waters;
    public Transform[] charGroups;
    public Cam cam;
    public Transform sailButton;
	//public Transform failMenu;
	public Animator startMenu;
	public GameObject setSail;
	public GameObject tutorial;

    void Start () 
	{
		GlobalVariables.levelProgress = 0f;		
		GlobalVariables.waterLeft = 0f;
		GlobalVariables.gameBegan = false;
		GlobalVariables.canDrag = true;
		GlobalVariables.win = false;
        StartLevel();
		if (tutorial && !GlobalVariables.firstTimePlay)
		{
			Destroy (tutorial);
		}

		InvokeRepeating ("PlayWaveSound", 0f, 3f);
	}    

	void PlayWaveSound()
	{
		SoundManager.Instance.PlayWaveSound ();
	}

    void StartLevel ()
    {
        GlobalVariables.peopleSaved = 0;

        if (GlobalVariables.level == 0)
        {
            GlobalVariables.peopleAlive = 2;
        }

		if (GlobalVariables.level == 1)
		{
			GlobalVariables.peopleAlive = 4;
		}
		if (GlobalVariables.level == 2)
		{
			GlobalVariables.peopleAlive = 7;
		}

    }

    public void RestartLevel()
    {
		GlobalVariables.lastCameraPosition = Camera.main.transform.position;
		SceneManager.LoadScene ("Main");
    }

    void Update () 
	{
		if (Input.GetKeyDown (KeyCode.Alpha1))
		{
			GlobalVariables.level = 0;
			GlobalVariables.startNewLevel = true;
		}

        if (Input.GetKeyDown(KeyCode.Alpha2))
        {
			waters [0].gameObject.SetActive (false);
			boats [0].gameObject.SetActive (false);
            GlobalVariables.level = 1;
            GlobalVariables.startNewLevel = true;
        }

        if (!CheckFail ())
		{

			Debug.Log ("level: " + GlobalVariables.level);

			if (GlobalVariables.peopleSaved == GlobalVariables.peopleAlive && !GlobalVariables.startNewLevel2)
			{
				GlobalVariables.peopleSaved = 0;
				GlobalVariables.startNewLevel = true;
			}

			if (GlobalVariables.startNewLevel)
			{
				GlobalVariables.startNewLevel = false;
				GlobalVariables.controlsEnabled = false;
				waters [GlobalVariables.level + 1].gameObject.SetActive (true);
				boats [GlobalVariables.level + 1].gameObject.SetActive (true);
				charGroups [GlobalVariables.level].gameObject.SetActive (true);
				cam.SetTargetPosition (boats [GlobalVariables.level + 1].transform.position);
				cam.SetBoat (boats [GlobalVariables.level + 1].transform);
				Debug.Log ("newlevel1");
			}

			if (GlobalVariables.startNewLevel2)
			{
				GlobalVariables.startNewLevel2 = false;
				waters [GlobalVariables.level].gameObject.SetActive (false);
				boats [GlobalVariables.level].gameObject.SetActive (false);
				GlobalVariables.level++;            
				GlobalVariables.canDrag = true;
				sailButton.gameObject.SetActive (true);
				Debug.Log ("newlevel2");
				StartLevel ();
			}
		}
	}

	bool CheckFail ()
	{
        Debug.Log(GlobalVariables.peopleAlive);

		if (GlobalVariables.peopleAlive <= 0)
		{
			GlobalVariables.canDrag = true;
            //GlobalVariables.gameBegan = false;
            //SceneManager.LoadScene("Main");
			//failMenu.gameObject.SetActive(true);
			return true;
		}
		return false;
	}

	public void begin ()
	{
		GlobalVariables.gameBegan = true;
		GlobalVariables.canDrag = false;
		startMenu.SetBool ("CloseMenu", true);
        //sailButton.gameObject.SetActive(false);
		boats [GlobalVariables.level].UnFreezeX ();
		if (tutorial && GlobalVariables.firstTimePlay)
		{
			Destroy (tutorial);
			GlobalVariables.firstTimePlay = false;
		}
	}

	/*public void StartGame ()
	{
		//GlobalVariables.canDrag = true;
		startMenu.GetComponent<Animator> ().SetBool ("CloseMenu", true);
		//setSail.SetActive (true);
		//GlobalVariables.gameStarted = true;
	}*/

	public void Win ()
	{
		//GlobalVariables.canDrag = true;
		if (!GlobalVariables.win)
		{
			GlobalVariables.win = true;
			SoundManager.Instance.ChangeMusic (1);
		}
	}
}
