﻿using UnityEngine;
using System.Collections;


//if you turn down this code, you will turn of the mouse drag effect.
public class MouseDrag : MonoBehaviour {

	public SpringJoint2D spring;

	void Awake()
	{

		spring = this.gameObject.GetComponent<SpringJoint2D>(); 
		spring.connectedAnchor = gameObject.transform.position;
		gameObject.AddComponent<LineRenderer> ();

	}


	void OnMouseDown()
	{
		if (GlobalVariables.canDrag)
		{
			spring.enabled = true;
			spring.connectedAnchor = gameObject.transform.position;
		}

	}


	void OnMouseDrag()        
	{

		if (spring.enabled == true && GlobalVariables.canDrag) 
		{
			Vector2 cursorPosition = Camera.main.ScreenToWorldPoint (Input.mousePosition);
			spring.connectedAnchor = cursorPosition;
		}
	}


	void OnMouseUp()        
	{
		if (GlobalVariables.canDrag)
		{
			spring.enabled = false;
		}

	}

}