﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class NpcStatementManager : MonoBehaviour {

	public MouseDrag body;
	public SpringJoint2D[] LimbsWithForse;

    private bool isAlive = true;

    void Update ()
    {
        if(isAlive)
        {
            if (this.transform.GetChild(0).position.y < GlobalVariables.yCoordOfDeath)
            {
                Die();
            }
        }        
    }

	public void TurnOffMouseDrag ()
	{
		body.enabled = false;
	}

	public void TurnOnMouseDrag ()
	{
		body.enabled = true;
	}

	public void Die ()
	{
        isAlive = false;

		foreach (SpringJoint2D i in LimbsWithForse)
		{
			i.enabled = false;
		}

		if (GlobalVariables.gameBegan && !GlobalVariables.win)
		{
			GlobalVariables.peopleAlive--;
			SoundManager.Instance.PlaySound (2);
			//Camera.main.GetComponent<Cam> ().ShakeCam (0.1f, 50f, 0.4f);
		}
	}
}
