﻿using UnityEngine;
using System.Collections;

public class SoundManager : MonoBehaviour
{
    public AudioClip[] sounds;
    public AudioClip[] musics;

    private static SoundManager instance = null;

    public static SoundManager Instance
    {
        get { return instance; }
    }

    void Awake()
    {
        if (instance != null && instance != this) 
        {
            Destroy(this.gameObject);
            return;
        }
        else
        {
            instance = this;
        }

        DontDestroyOnLoad(this.gameObject);
    }

    public void PlayWaveSound ()
    {
		int number = Random.Range (0, 2);
		Debug.Log ("sound " + number);
		this.GetComponent<AudioSource>().PlayOneShot(sounds[number], 0.3f);
    }

    public void PlaySound(int number)
    {
		
        this.GetComponent<AudioSource>().PlayOneShot(sounds[number], 0.5f);
    }

    public void ChangeMusic(int number)
    {
		this.GetComponent<AudioSource>().Stop();
        this.GetComponent<AudioSource>().clip = musics[number];
		this.GetComponent<AudioSource>().Play();
    }
}
